#include <stdio.h>

main(int argc, char *argv[])
{
	void	view_file(FILE *);
	void	fatal(char *);
	FILE	*fp;

	if(argc == 1)
		{
		puts(" : a.out file_name");
		exit(0);
		}
	else	*argv++;

	do	{
		if(*argv)
			{
			puts(*argv);
			if((fp = fopen(*argv, "r")) == NULL)
				fatal("fopen");
			view_file(fp);
			fclose(fp);
			}
			
		*argv++;
	} while(*argv);
}

void
view_file(FILE *fp)
{
	int	c;

	while((c = getc(fp)) != EOF)
		putc(c, stdout);

}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
