#include <stdio.h>
#define ON	1
#define OFF	1

unsigned int n_flag, b_flag, s_flag;

main(int argc, char *argv[])
{
	void	view_file(FILE *);
	void	fatal(char *);
	FILE	*fp;
	int	option;

	if(argc == 1)
		{
		puts(" : a.out -b file_name or a.out -s file_name");
		exit(0);
		}
		
	/*  ɼ ó */
	while((option = getopt(argc, argv, "nsb")) != EOF) 
		switch(option)
		{
			case 'n' : n_flag = ON;
				break;
			case 's' : s_flag = ON;
				break;
			case 'b' : b_flag = ON;
				break;
		}

	if(argc == 2) argv++;
	else	argv += 2;

	/*  ó */
	do	{
		if(*argv)
			{
			puts(*argv);
			if((fp = fopen(*argv, "r")) == NULL)
				fatal("fopen");
			view_file(fp);
			fclose(fp);
			}
			
		*argv++;
	} while(*argv);
}

void
view_file(FILE *fp)
{
	int	c;
	int	count = 1;
	int	count_carrage_return = 0;

	/* ù  ó */
	if(count == 1 && (n_flag == ON || b_flag == ON))
		printf("    1\t");

	/* ɼǺ ó */
	while((c = getc(fp)) != EOF)
		{
		if(n_flag == ON && c == '\n')
			{
			if((c = getc(fp)) == EOF)
				break;
			ungetc(c, fp);
			printf("\n%5d\t", ++count);
			continue;
			}
		if(b_flag == ON && c == '\n')
			{
			while((c = getc(fp)) == '\n')
				putchar('\n');

			ungetc(c, fp);
			if((c = getc(fp)) == EOF)
				break;
			printf("\n%5d\t", ++count);
			}
		if(s_flag == ON && c == '\n')
			{
			int	imsi;
			if((imsi = getc(fp)) == EOF)
				break;
			else	ungetc(imsi, fp);
			putc(c, stdout);

			while((c = getc(fp)) == '\n')
				count_carrage_return++;;
			if(count_carrage_return > 1 )
				{
				count_carrage_return = 0;
				putchar('\n');
				}
			}

		putc(c, stdout);

		}

	putchar('\n');
}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
