#include <stdio.h>
#define ON	1

unsigned int n_flag, b_flag, s_flag;

main(int argc, char *argv[])
{
	void	view_file(FILE *);
	void	fatal(char *);
	FILE	*fp;
	int	option;

	if(argc == 1)
		{
		puts(" : a.out -n file_name");
		exit(0);
		}
		
	/*  ɼ ó */
	while((option = getopt(argc, argv, "nsb")) != EOF) 
		switch(option)
		{
			case 'n' : n_flag = ON;
				break;
			case 's' : puts("not yet");
				break;
			case 'b' : puts("not yet");
				break;
		}

	if(argc == 2) argv++;
	else	argv += 2;

	/*  ó */
	do	{
		if(*argv)
			{
			puts(*argv);
			if((fp = fopen(*argv, "r")) == NULL)
				fatal("fopen");
			view_file(fp);
			fclose(fp);
			}
			
		*argv++;
	} while(*argv);
}

void
view_file(FILE *fp)
{
	int	c;
	int	count = 1;

	/* ù  ó */
	if(count == 1 && n_flag == ON)
		printf("1\t");

	while((c = getc(fp)) != EOF)
		{
		if(n_flag == ON && c == '\n')
			{
			if((c = getc(fp)) == EOF)
				break;
			ungetc(c, fp);
			printf("\n%d\t", ++count);
			continue;
			}
		putc(c, stdout);
		}

	putchar('\n');
}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
