#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>

#define  BUF_SIZE	1024
#define  ON		1

int	a_flag, s_flag;
int	total_size;

main(int argc, char *argv[])
{
	int	excute_du(DIR *, char *);
	void	fatal(char *);
        DIR     *dir;
	int	option;
	int	found_option = 0;
	char	file[1024];
        struct  dirent *directory;

	while((option = getopt(argc, argv, "as")) != EOF)
		switch(option)
		{
		case 'a' : a_flag = ON;
		break;
		case 's' : s_flag = ON;
		break;
		}
	if(argc == 1) strcpy(file, ".");
	else	*argv++;

	do	{
		if(*argv)
		if(!strncmp(*argv, "-", 1))
			{
			found_option = ON;
			*argv++;
			}

		if(argc > 1 && found_option != ON)
			strcpy(file, *argv++);
		if(argc == 2 && found_option == ON)
			strcpy(file, ".");
		if(argc > 2 && found_option == ON)
			strcpy(file, *argv++);

	        if((dir = opendir(file)) == NULL)
			fatal("opendir");

       		total_size = excute_du(dir, file);

		if(argc == 1) break;

		if(s_flag == ON)
			printf("%-7d %s\n", total_size, file);

	} while(*argv);

	closedir(dir);

}

int
excute_du(DIR *dir, char *file)
{
	void	fatal(char *);
	DIR	*imsi_dir;
    	struct  dirent  *directory;
    	struct  stat    file_stat;
	int	get_size = 0;
	char	buff[1024];
	int	directory_size = 0;
	int	sub_directory_size = 0;


    	while(directory = readdir(dir))
		{
		if(!strcmp(directory->d_name, ".") ||
			!strcmp(directory->d_name, ".."))
			continue;

		if(directory->d_ino == 0)
		    continue;

		sprintf(buff, "%s/%s", file, directory->d_name);
		if(lstat(buff, &file_stat) < 0)
			fatal("stat");
		get_size = (file_stat.st_size + (BUF_SIZE - 1)) / BUF_SIZE;
		directory_size += get_size;

		if(a_flag == ON && !S_ISDIR(file_stat.st_mode))
			printf("%-7d %s\n", get_size, buff);

		if(S_ISDIR(file_stat.st_mode))
			{
			int	imsi_size = 0;

			imsi_dir = opendir(buff);
			imsi_size = excute_du(imsi_dir, buff);
			sub_directory_size += imsi_size;
			}
		}


		directory_size += sub_directory_size;
		total_size += directory_size;

		if(s_flag != ON)
			printf("%-7d %s\n", directory_size, file);

		return directory_size;

}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
