#include <stdio.h>
#include <sys/fcntl.h>
#include <termios.h>

main(int argc, char *argv[ ])
{
	struct termios  modes, old_modes;

	char	c;
	FILE	*fd;
	int	count = 0;


	tcgetattr(0, &modes);
	old_modes = modes;

	modes.c_lflag &= ~(ICANON | ECHO);
	tcsetattr(0, TCSAFLUSH, &modes);

	if((fd = fopen(argv[1], "r")) == NULL)
		{
		tcsetattr(0, TCSAFLUSH, &old_modes);
		perror("fopen");
		exit(1);
		}

	while((c = getc(fd)) != EOF)
		{
		if(c == '\n') count++;
		if((count+1) % 10 == 0)
			{
			count = 0;
			printf("\nany key press ...\n");
			fgetc(stdin);
			putchar(c);
			continue;
			}

		putchar(c);

		}

	tcsetattr(0, TCSAFLUSH, &old_modes);
}
