#include <stdio.h>
#include <fcntl.h>
#include <dirent.h>
#include <sys/stat.h>

main(int argc, char *argv[])
{
	void    fatal(char *);
	int     fd;
	DIR     *dir;
	char    file[BUFSIZ + 1];
	struct  dirent  *directory;
	struct  stat    file_stat;


	if(argc != 2)
		{
		puts(" : a.out directory_name");
		exit(0);
		}

	if((dir = opendir(argv[1])) == NULL)
		fatal("opendir");

	while(directory = readdir(dir))
		{
		if(strcmp(directory->d_name, ".") == 0 ||
			strcmp(directory->d_name, "..") == 0)
			continue;
		if(directory->d_ino == 0)
			continue;

		sprintf(file, "%s/%s", argv[1], directory->d_name);
		printf("%ld %s\t", directory->d_ino, directory->d_name);

		}

	putchar('\n');
	closedir(dir);
}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
